#include "stdafx.h"

#include "..\..\DuiLib\UIlib.h"
#include "UIListCommonDefine.hpp"


namespace DuiLib
{

double CalculateDelay(double state)
{
    return pow(state, 2);
}

void Node::set_parent(Node* parent)
{
	parent_ = parent;
}

Node::Node()
	: parent_(NULL)
	,m_userData(0)
    ,m_pCompareFunc(NULL)
    ,m_compareData(0)
{}

Node::Node(NodeData t)
	: data_(t)
	, parent_(NULL)
    ,m_userData(0)
	,m_pCompareFunc(NULL),
    m_compareData(0)
{}

Node::Node(NodeData t, Node* parent)
: data_ (t)
, parent_ (parent)
, m_userData(0)
, m_pCompareFunc(NULL)
{}

Node::~Node() 
{
	for (int i = 0; i < num_children(); ++i)
		delete children_[i]; 
}

NodeData& Node::data()
{
	return data_;
}

NE_MEMBER_DATA&Node:: member_data(){
	return member_data_;
}

void Node::SetMemberData(const NE_MEMBER_DATA* pdata){
    const NE_MEMBER_DATA data = *pdata;
    member_data_ = data;

  // CopyMemberData(*data);

}


int Node::num_children() const
{
	return static_cast<int>(children_.size());
}

Node* Node::child(int i)
{
	if(i >= children_.size() || i < 0)return NULL;
	return children_[i];
}

Node* Node::parent()
{
	return ( parent_);
}

bool Node::has_children() const
{
	return num_children() > 0;
}

bool Node::folder() const
{
	return data_.folder_;
}

void Node::add_child(Node* child)
{
	child->set_parent(this); 
	children_.push_back(child); 
}

void Node::insert_child(Node* child, int nIndex)
{	
	child->set_parent(this); 
	if(children_.size() > 0)
	{
		children_.insert(children_.begin() + nIndex, child);
	}
	else
	{
		children_.push_back(child);
	}
	
}

// insert_childǲһnodenIndexλá
// reinsert_childǴchildren_  vectorɾýڵ㣨delete²뵽nIndexλáʾǸnodechildren_ vectorﻻλá
void Node::reinsert_child(Node* child, int nIndex)
{	
	child->set_parent(this); 
	if(children_.size() > 0)
	{
		remove_child(child);
		children_.insert(children_.begin() + nIndex, child);
	}
	else
	{
		children_.push_back(child);
	}

}

void Node::remove_child(Node* child)
{
	Children::iterator iter = children_.begin();
	for (; iter < children_.end(); ++iter)
	{
		if (*iter == child) 
		{
			children_.erase(iter);
			return;
		}
	}
}

Node* Node::get_last_child()
{
	if (has_children())
	{
		return child(num_children() - 1)->get_last_child();
	}
	return this;
}

void Node::SortChidren(PNodeCompareFunc pCompareFunc)
{
	m_pCompareFunc = pCompareFunc;

/*
	vector<Node*> vecNodes;
	for(int i = 0; i < children_.size(); ++i)
	{
		vecNodes.push_back(children_.at(i));
	}*/
  

	qsort_s(&(children_.at(0)), children_.size(), sizeof(Node*), Node::ItemComareFunc, this);	
	/*vector<CControlUI*> vecItems;
	for(int i = 0; i < children_.size(); ++i)
	{
		vecItems.push_back(children_.at(i)->data().list_elment_);
	}
	*/
	/*IListItemUI *pItem = NULL;
	
	for (int i = 0; i < children_.size(); ++i)
	{
		pItem = (IListItemUI*)(static_cast<CControlUI*>(children_[i]->data().list_elment_)->GetInterface(TEXT("ListItem")));
		if (pItem)
		{
			pItem->SetIndex(i);
			pItem->Select(false);
		}
	}*/
}

int __cdecl Node::ItemComareFunc(void *pvlocale, const void *item1, const void *item2)
{
	Node *pThis = (Node*)pvlocale;
	if (!pThis || !item1 || !item2)
		return 0;
	return pThis->ItemComareFunc(item1, item2);
}

int __cdecl Node::ItemComareFunc(const void *elem1, const void *elem2)
{
	Node **pNode1 = (Node**)elem1;
	Node **pNode2 = (Node**)elem2;
    int status1 = (*pNode1)->data().status;
	int status2 = (*pNode2)->data().status;

	return m_pCompareFunc(&status1, &status2);
}

void Node::SetComapreData(int nData)
{
	m_compareData = nData;
}

int Node::GetCompareData()
{
	return m_compareData;
}

bool Node::IsRoot() const
{
	return (bool)(data_.level_ == -1);
}

}